library IEEE;
use IEEE.STD_LOGIC_1164.ALL;
use IEEE.STD_LOGIC_ARITH.ALL;
use IEEE.STD_LOGIC_UNSIGNED.ALL;

entity VGACounter is
    Port ( clk :     in   STD_LOGIC;
           rst :     in   STD_LOGIC;
           HSYNC :   out  STD_LOGIC;
           VSYNC :   out  STD_LOGIC; 
           PCount :  out  STD_LOGIC_VECTOR(9 downto 0);
           HLCount : out  STD_LOGIC_VECTOR(9 downto 0);
           VisArea : out  STD_LOGIC);
end VGACounter;

architecture Behavioral of VGACounter is
SIGNAL Pre_PCount : STD_LOGIC_VECTOR(9 DOWNTO 0) := "0000000000";
SIGNAL Pre_HLCount : STD_LOGIC_VECTOR(9 Downto 0) := "0000000000";
SIGNAL Pre_HSYNC : STD_LOGIC;
SIGNAL Pre_VSYNC : STD_LOGIC;
begin  
  PROCESS (clk, rst)
  begin
    if rst = '0' then -- Reset is active (low)
	   HSYNC <= '0';
		VSYNC <= '0'; 
	   Pre_HSYNC <= '0';
		Pre_VSYNC <= '0'; 
		Pre_PCount <= "0000000000";
		Pre_HLCount <= "0000000000";
	   VisArea <= '0'; 
	 else
  	   if clk = '1' then
        Pre_PCount <= Pre_PCount + 1;
      end if;
      if Pre_PCount = 800 then 
        Pre_PCount <= "0000000000";
        Pre_HLCount <= Pre_HLCount + 1;
        if Pre_HLCount = 521 then
          Pre_HLCount <= "0000000000";
		  end if;
	   End if;
	 end if;
	 if clk = '1' then
	   if Pre_PCount = 0 then
		  Pre_HSYNC <= '0';
		end if;
		if Pre_PCount = 96 then
		  Pre_HSYNC <= '1';
		end if;
		if Pre_HLCount = 0 then
		  Pre_VSYNC <= '0';
		end if;
		if Pre_HLCount = 2 then
		  Pre_VSYNC <= '1';
		end if;
		HSYNC <= Pre_HSYNC;
		VSYNC <= Pre_VSYNC;
		if Pre_HSYNC = '1' and Pre_VSYNC = '1' then
		  VisArea <= '1';
		  else
		    VisArea <= '0';
		End if;
	 end if;
  END PROCESS;
  PCount <= Pre_PCount;
  HLCount <= Pre_HLCount;
 end Behavioral;